Program Rocket3;

    {University of Malta Continuous Simulation System}
    {Author: J.Sklenar	                February 1992}

       { Experiment 3 : rocket, fixed number of  }
       { experiments, looking for the best times }
       { to fire stages 2 and 3. Possibility to  }
       { change the times of their firings. Max. }
       { altitude reached is displayed. 	 }
       {        !!!  ANIMATION  !!!              }

{ This is the simple system for computer simulation of	  }
{ dynamic systems. The system simulated may be expressed  }
{ as a block diagram or a set of equations. The user pro- }
{ grams the activity in one simulation step. The algorithm}
{ is like that: 					  }
{	   system_initiation				  }
{	   for all experiments do			  }
{		      model_initiation			  }
{		      repeat				  }
{			  time := time + delta_t	  }
{			  simulation_step_activity	  }
{			  print if necessary		  }
{			  plot	if necessary		  }
{		      until termination_condition	  }
{		      experiment_evaluation		  }
{		      model_updating			  }
{	   termination					  }
{							  }
{notes: - time is expressed as a real variable in abstract}
{	  units (system variable time), 		  }
{	- user is given some standard constants,types,	  }
{	  variables,procedures and functions. Definition  }
{	  of application dependent objects is supposed,   }
{	- we suggest to store the plotted data in arrayes }
{	  (of type collectr or collecti) and to draw	  }
{	  graphs after the completion of the experiment.  }
{							  }
{ EXAMPLE: The system simulated is the model rocket. The  }
{   engine fires in three stages, each stage takes 1 sec. }
{   The constant accelerations of the stages are IACC,40  }
{   and 30 m/s^2. The stages fire at times 0, t2 and t3.  }
{   Between stages there is the gravity -9.8 m/s^2.	  }
{   Equations:						  }
{    altitude = integral(velocity) + initial_altitude	  }
{    velocity = integral(acceleration) + initial_velocity }
{   The simulation finishes when the altitude becomes 0.  }

{$N+,E+}
Uses Graph, Crt;

{system constants: }

const
   prdel    =	2.0;   {printing interval}
   outdel   =	1.0;   {plotting interval}
   delt     =  0.05;   {integration step}
   numpoint =	150;   {maximum number of points to collect}
   numrep   =	  2;   {number of repetitions}
   numint   =	  1;   {number of integration methods}

{user defined constants: }

   scale    =     2;   {Initial scale of the altitude on screen}
   xstep    =    10;   {Step of x axis for plotting}
   numx     =    69;   {Number of points to plot}
   wr       =    20;   {Rocket width}
   hr       =    48;   {Rocket hight}
   wf       =    20;   {Fire width}
   hf       =    35;   {Fire hight}


{system types: }

type
   collectr = array[1..numpoint] of real; {to collect real values}
   collecti = array[1..numpoint] of integer; { -"- integer values}
   numrept  = 1..numrep;     {to number experiments}
   numpoit  = 1..numpoint;   {for indexes of arrays}

{user defined types: }

{system variables: }

var
   time     : real;      {model time}
   exper    : numrept;   {experiment number}
   countpr  : real;      {counter for printing}
   countpl  : real;      {counter for plotting}

{user defined variables: }

   alt,vel,acc : real;     {altitude,velocity,acceleration}
   ialt,ivel,iacc : real;  {initial values}
   maxalt: real;           {max. altitude reached}
   t2: real;               {time of the 2nd stage firing}
   t3: real;               {time of the 3rd stage firing}
   altpl,velpl : collectr; {arrays for collection}
   colpl : numpoit;        {index for collections}
   graphdriver,graphmode:integer;   {used by graphics}
   X0,Y0 : word;           {Coordinates for Get/PutImage}
   Size : longint;         {Memory size  for Get/PutImage}
   Rock,Fire : pointer;    {Pointers to images}
   fires : boolean;        {Fire displayed}
   ascale : real;          {Scaling altitude on screen}


{system procedures and functions: }

   function step (t:real):integer;  {step of CSMP type}
   begin
     if (time >= t) then step:=1 else step:=0
   end;

   procedure integral(input:real;var output:real);
     {integration methods:    }
     {  so far only Euler     }
   begin
     output := output + delt*input
   end;

{user defined procedures and functions}
{must include:                        }
{ initiation  = first model initiation }
{ modelinit   = experiment initiation  }
{ simulation  = one simulation step    }
{ printing    = print/collect values   }
{ plotting    = plot/collect values    }
{ expter      = termination test       }
{ modelupdate = model updating         }
{ expeval     = experiment evaluation  }
{ termination = final actions          }


 procedure Drawrocket(xr,yr,wr,hr: word);
 begin
    SetColor(lightblue);
    MoveTo(xr-wr div 2, yr);
    LineRel(wr,0);
    LineRel(-wr div 3, -hr div 5);
    LineRel(0, -3*hr div 5);
    LineTo(xr, yr-hr);
    LineRel(-wr div 6, hr div 5);
    LineRel(0, 3*hr div 5);
    LineTo(xr-wr div 2, yr);
    SetFillStyle(SolidFill, blue);
    FloodFill(xr, yr-hr div 2, lightblue);
 end;

 procedure Drawfire(xf,yf,wf,hf: word);
 begin
    SetColor(lightred);
    MoveTo(xf-wf div 4, yf+2);
    LineRel(-wf div 4, hf-3);
    LineRel(wf, 0);
    LineRel(-wf div 4, -(hf-3));
    LineTo(xf-wf div 4, yf+2);
    SetFillStyle(SolidFill, red);
    FloodFill(xf, yf+hf div 2, lightred);
 end;

 procedure Status;   {Rocket status}
 begin
   GotoXY(2,3);
   write('Altitude = ',alt:9:1,' m');
   GotoXY(2,5);
   write('Velocity = ',vel:9:1,' m/s');
   GotoXY(2,7);
   write('Acceleration = ',acc:5:1,' m/s^2');
 end;

  procedure initiation;
  begin
   DirectVideo := false;
   graphdriver:=Detect;
   InitGraph(graphdriver,graphmode,'c:\tp\bgi');
   SetBkColor(black);
   X0 := GetMaxX div 2 - 30;
   Y0 := GetMaxY div 2;

      {Draw and save rocket image}
   Drawrocket(X0 + wr div 2,Y0 + hr,wr,hr);
   Size := Imagesize(X0,Y0,X0+wr,Y0+hr);
   GetMem(Rock,Size);
   GetImage(X0,Y0,X0+wr,Y0+hr,Rock^);
   PutImage(X0,Y0,Rock^,XORput);

      {Draw and save fire image}
   Drawfire(X0 + wr div 2,Y0 + hr ,wf,hf);
   Size := Imagesize(X0,Y0+hr,X0+wf,Y0+hr+hf+10);
   GetMem(Fire,Size);
   GetImage(X0,Y0+hr,X0+wf,Y0+hr+hf+10,Fire^);
   PutImage(X0,Y0+hr,Fire^,XORput);

   Textbackground(blue);
   Textcolor(yellow);
   RestoreCrtMode;
   ClrScr;
   GotoXY(15,2);
   writeln('MODEL INITIALIZATION');
   GotoXY(1,5);
   write(' Enter the initial altitude ( try 0 )  :     ');
   readln(ialt);
   GotoXY(1,7);
   write(' Enter the initial velocity ( try 40 )  :    ');
   readln(ivel);
   GotoXY(1,9);
   write(' Enter the initial acceleration ( try 50 ) : ');
   readln(iacc);
  end;

  procedure modelinit;
  var i:integer;
  begin
   Textbackground(blue);
   Textcolor(yellow);
   RestoreCrtMode;
   ClrScr;
   GotoXY(1,5);
   write(' Enter the time t2 ( t2>=1; try 10) :  ');
   readln(t2);
   GotoXY(1,7);
   write(' Enter the time t3 ( t3>=2; try 15) :  ');
   readln(t3);
   ascale:=scale;
    SetGraphMode(graphmode);
    SetBkColor(black);
    Y0 := GetMaxY  - round(ialt/ascale) - hr;
    PutImage(X0,Y0,Rock^,XORput);
    PutImage(X0,Y0+hr+2,Fire^,XORput);
   GotoXY(47,5);
   write('The screen hight =', GetMaxY*ascale:5:0, ' metres');
      fires:=true;
      alt:=ialt;
      vel:=ivel;
      time:=0;
      colpl:=1;
      for i:=1 to numpoint do
      begin
         altpl[i]:=0;
         velpl[i]:=0
      end;
      maxalt:=0;
   end;

   procedure modelupdate;
   begin end;

   procedure termination;
   begin
      RestoreCrtMode;
   end;

   procedure simulation;
    begin

    { at first compute the acceleration using the step function: }

      acc:=iacc-(iacc+9.8)*step(1.0)+49.8*step(t2)
           -49.8*step(t2+1.0)+39.8*step(t3)-39.8*step(t3+1.0);

    { then compute the velocity as the output of the integrator  }
    { the input of which is the acceleration:                    }

      integral(acc,vel);

    { altitude is the integral of velocity: }

      integral(vel,alt);
      if (alt>maxalt) then maxalt := alt;

    { altitude must be nonnegative: }

      if (alt<0) then alt:=0;

    { show the rocket at the new position: }

      PutImage(X0,Y0,Rock^,XORput); {clear the previous rocket}
      if fires then
        PutImage(X0,Y0+hr+2,Fire^,XORput); {clear the previous fire}
      fires:=false;

      { rescale if necessary: }

      if round(alt/ascale) > (GetMaxY - 50) then begin
          ascale := ascale*1.5;
          GotoXY(47,5);
          write('The screen hight =', GetMaxY*ascale:5:0, ' metres');
      end;

      Y0 := GetMaxY - round(alt/ascale) - hr;
      PutImage(X0,Y0,Rock^,XORput); {new rocket}
      if acc>0.0 then begin
        PutImage(X0,Y0+hr+2,Fire^,XORput); {new fire}
        fires:=true;
      end;
      Status;
      Delay(4);
   end;

   procedure printing;
   begin end;

   procedure plotting;
   begin
      altpl[colpl]:=alt;
      colpl:=colpl+1
   end;

   function expter: boolean;
   begin
      expter:=(alt=0)
   end;

   procedure expeval;
   var i,x,y,h:integer;
   begin
      GoToXY(2,16);
      write('Maximum altitude = ', maxalt:10:2,' metres');
      GoToXY(2,18);
      write('Flight duration  = ', time:10:2,' seconds');
      GoToXY(2,23);
      write('Press Enter to plot');
      readln;
      SetGraphMode(graphmode);
      SetBkColor(black);
      SetColor(yellow);
      h := GetMaxY div 5;
      SetTextStyle(DefaultFont, HorizDir, 2);
      OutTextXY(370, h div 2, 'Rocket Flight');
      GotoXY(40,8);
      write('Maximum altitude = ', maxalt:9:1,' metres');
      GotoXY(40,10);
      write('Flight duration  = ', time:9:1,' seconds');
      x:=0;              { origin }
      y:=GetMaxY-10;
      SetColor(red);
      Moveto(x,y-round(ialt/ascale));
      SetTextStyle(DefaultFont, HorizDir, 1);
      OutText('Initial Altitude');
      Moveto(x,y-round(ialt/ascale));
      for i:=1 to numx do
      begin
         x:=x+xstep;
         LineTo(x,y-round(altpl[i]/ascale));
      end;
      Moveto(400, y - h div 2);
      SetColor(yellow);
      OutText('Press Enter to continue');
      readln
  end;


begin                {of the program body}
   initiation;
   for exper:=1 to numrep do
   begin
      modelinit;
      countpr:=0;
      countpl:=0;
      repeat
         time:=time+delt;
         countpr:=countpr+delt;
         countpl:=countpl+delt;
         simulation;
         if countpr>=prdel then
         begin
            printing;
            countpr:=0
         end;
         if countpl>=outdel then
         begin
            plotting;
            countpl:=0
         end;
     until (expter);
     expeval;
     modelupdate;
   end;            {of experiment}
   termination
end.

